<?php

namespace Drupal\scheduler_field\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\datetime_range\Plugin\Field\FieldWidget\DateRangeDefaultWidget;

/**
 * Plugin implementation of the 'scheduler_field_default' widget.
 *
 * @FieldWidget(
 *   id = "scheduler_field_default",
 *   label = @Translation("Scheduler field"),
 *   field_types = {
 *     "scheduler_field"
 *   }
 * )
 */
class SchedulerFieldDefaultWidget extends DateRangeDefaultWidget {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element = parent::formElement($items, $delta, $element, $form, $form_state);
    $element['scheduler_type'] = [
      '#type' => 'select',
      '#title' => $this->t('Scheduler type'),
      '#options' => $items[$delta]->getSchedulerTypeOptions(),
      '#default_value' => $items[$delta]->scheduler_type,
      '#weight' => -10,
    ];

    return $element;
  }

}
